#!/bin/bash
#set -x

if [ -z "$1" ]; then
 exit
fi

ver_ok=0
base_ver="10.10"
ver=$(sw_vers | grep ProductVersion | cut -d':' -f2 | tr -d '[:blank:]')
if [ $(echo -e $base_ver"\n"$ver | sort -rV | tail -1) == "$base_ver" ]
then 
   ver_ok=1
fi

ipath=/Library/imPcRemote

if [ -f "$ipath/ssvnc/libjpeg.9.dylib" ]; then
 rm $ipath/ssvnc/libjpeg.9.dylib
fi

if [ -f "$1/ultravnc_dsm_helper" ]; then
 rm $ipath/ssvnc/ultravnc_dsm_helper.old
 mv -f $ipath/ssvnc/ultravnc_dsm_helper $ipath/ssvnc/ultravnc_dsm_helper.old
 cp -Rpf $1/ultravnc_dsm_helper $ipath/ssvnc
 chmod -R 775 $ipath/ssvnc/ultravnc_dsm_helper
 if [ -f "$ipath/ssvnc/ultravnc_dsm_helper" ]; then
  rm $ipath/ssvnc/ultravnc_dsm_helper.old
 fi
fi

if [ -f "$1/x11vnc" ]; then
 if [ $ver_ok == 1 ]; then
  rm $ipath/ssvnc/x11vnc.old
  mv -f $ipath/ssvnc/x11vnc $ipath/ssvnc/x11vnc.old
  cp -Rpf $1/x11vnc $ipath/ssvnc
  chmod -R 775 $ipath/ssvnc/x11vnc
  if [ -f "$ipath/ssvnc/x11vnc" ]; then
   rm $ipath/ssvnc/x11vnc.old
  fi
 fi
fi

touch /tmp/impctray_stop
sleep 4s
killall imPcRemoteTray
sleep 1s
launchctl unload /Library/LaunchAgents/com.impcremote.agent.plist
rm -rf /Applications/imPcRemoteTray.app
cp -Rpf $1/imPcRemoteTray.app /Applications
chmod -R 775  /Applications/imPcRemoteTray.app
rm /tmp/impctray_stop

if [ -f "$1/com.impcremote.prelogin.plist" ]; then
 launchctl unload /Library/LaunchAgents/com.impcremote.prelogin.plist
 rm -rf $ipath/imPcRemotePreLogin.app
 rm $ipath/impcremote_prelogin.sh
 mv -f $1/com.impcremote.prelogin.plist /Library/LaunchAgents
 chown root:wheel /Library/LaunchAgents/com.impcremote.prelogin.plist
 chmod 644 /Library/LaunchAgents/com.impcremote.prelogin.plist
 launchctl load /Library/LaunchAgents/com.impcremote.prelogin.plist
fi

if [ -f "/Library/LaunchAgents/com.impcremote.bash_privacy.plist" ]; then
 launchctl unload /Library/LaunchAgents/com.impcremote.bash_privacy.plist
 rm /Library/LaunchAgents/com.impcremote.bash_privacy.plist
 rm $ipath/bash_privacy
fi

if [ -f "$1/com.impcremote.impc_vnc_agent.plist" ]; then
 launchctl unload /Library/LaunchAgents/com.impcremote.impc_vnc_agent.plist
 mv -f $1/com.impcremote.impc_vnc_agent.plist /Library/LaunchAgents
 chown root:wheel /Library/LaunchAgents/com.impcremote.impc_vnc_agent.plist
 chmod 644 /Library/LaunchAgents/com.impcremote.impc_vnc_agent.plist
 launchctl load /Library/LaunchAgents/com.impcremote.impc_vnc_agent.plist
fi

launchctl stop com.impcremote.impc_vnc_agent
sleep 10s
cp -Rpf $1/impc_vnc_agent $ipath
chmod -R 775 $ipath/impc_vnc_agent

launchctl unload /Library/LaunchDaemons/com.impcremote.service.plist
sleep 30s
rm -f $ipath/imPcRemoteService
cp -Rpf $1/imPcRemoteService $ipath
chmod -R 775 $ipath/imPcRemoteService

if [ -f "$ipath/impcremote_start.sh" ]; then
 rm -f $ipath/impcremote_start.sh
fi

if [ -f "$1/com.impcremote.service.plist" ]; then
 launchctl unload /Library/LaunchDaemons/com.impcremote.service.plist
 mv -f $1/com.impcremote.service.plist /Library/LaunchDaemons
 chown root:wheel /Library/LaunchDaemons/com.impcremote.service.plist
 chmod 644 /Library/LaunchDaemons/com.impcremote.service.plist
 launchctl load /Library/LaunchDaemons/com.impcremote.service.plist
fi

launchctl load /Library/LaunchDaemons/com.impcremote.service.plist
sleep 10s

rm /Library/LaunchDaemons/com.impcremote.update.plist

launchctl load /Library/LaunchAgents/com.impcremote.agent.plist

